%define GITDATE        20160223
%define GITCOMMIT      dbbfda4

%global debug_package %{nil}

Name:       SLOF
Version:    %{GITDATE}
Release:    6.git%{GITCOMMIT}%{?dist}
Summary:    Slimline Open Firmware
Group:      Applications/Emulators
License:    BSD
URL:        http://www.openfirmware.info/SLOF

Source0: http://batcave.lab.eng.brq.redhat.com/www/SLOF-dbbfda4.tar.bz2

Patch0002: 0002-spec-Remove-FlashingSLOF.pdf.patch
# For bz#1310737 - SLOF cannot boot without a console
Patch3: slof-dev-null-The-read-function-has-to-return-0-if-nothin.patch
# For bz#1301081 - IPv6 boot does not work in SLOF when TFTP server is behind a router
Patch4: slof-ipv6-Add-support-for-sending-packets-through-a-route.patch
# For bz#1331698 - Network booting in grub fails when using virtio-net and SLOF-20160223-0
Patch5: slof-virtio-net-initialize-to-populate-mac-address.patch
# For bz#1287716 - IPv6 boot support in SLOF
Patch6: slof-ipv6-Do-not-use-unitialized-MAC-address-array.patch
# For bz#1287716 - IPv6 boot support in SLOF
Patch7: slof-ipv6-send_ipv6-has-to-return-after-doing-NDP.patch
# For bz#1287716 - IPv6 boot support in SLOF
Patch8: slof-ipv6-Fix-possible-NULL-pointer-dereference-in-send_i.patch
# For bz#1287716 - IPv6 boot support in SLOF
Patch9: slof-ipv6-Clear-memory-after-malloc-if-necessary.patch
# For bz#1287716 - IPv6 boot support in SLOF
Patch10: slof-ipv6-Fix-memory-leak-in-set_ipv6_address-ip6_create_.patch
# For bz#1287716 - IPv6 boot support in SLOF
Patch11: slof-ipv6-Indent-code-with-tabs-not-with-spaces.patch
# For bz#1287716 - IPv6 boot support in SLOF
Patch12: slof-ipv6-Fix-NULL-pointer-dereference-in-ip6addr_add.patch
# For bz#1287716 - IPv6 boot support in SLOF
Patch13: slof-ipv6-Replace-magic-number-1500-with-ETH_MTU_SIZE-i.e.patch
# For bz#1339528 - SLOF boot menu gets delayed if press 'F12' key for multiple times
Patch14: slof-xhci-add-memory-barrier-after-filling-the-trb.patch
# For bz#1339528 - SLOF boot menu gets delayed if press 'F12' key for multiple times
Patch15: slof-xhci-fix-missing-keys-from-keyboard.patch
# For bz#1339528 - SLOF boot menu gets delayed if press 'F12' key for multiple times
Patch16: slof-Improve-F12-key-handling-in-boot-menu.patch
# For bz#1352821 - Key  "," can not be inputted during SLOF and yaboot stage
Patch17: slof-usb-hid-Fix-non-working-comma-key.patch
# For bz#1352765 - SLOF can not handle devices attached to an XHCI USB hub
Patch18: slof-usb-Move-XHCI-port-state-arrays-from-header-to-.c-fi.patch
# For bz#1352765 - SLOF can not handle devices attached to an XHCI USB hub
Patch19: slof-usb-Increase-amount-of-maximum-slot-IDs-and-add-a-sa.patch
# For bz#1352765 - SLOF can not handle devices attached to an XHCI USB hub
Patch20: slof-usb-Initialize-USB3-devices-on-a-hub-and-keep-track-.patch
# For bz#1352765 - SLOF can not handle devices attached to an XHCI USB hub
Patch21: slof-usb-Build-correct-route-string-for-USB3-devices-behi.patch
# For bz#1352765 - SLOF can not handle devices attached to an XHCI USB hub
Patch22: slof-usb-Set-XHCI-slot-speed-according-to-port-status.patch

BuildArch: noarch

BuildRequires:  binutils
BuildRequires:  perl(Data::Dumper)

%description
Slimline Open Firmware (SLOF) is initialization and boot source code
based on the IEEE-1275 (Open Firmware) standard, developed by
engineers of the IBM Corporation.

The SLOF source code provides illustrates what's needed to initialize
and boot Linux or a hypervisor on the industry Open Firmware boot
standard.

Note that you normally wouldn't need to install this package
separately.  It is a dependency of qemu-system-ppc64.

%prep
%setup -q -n SLOF-%{GITCOMMIT}

%patch0002 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1
%patch19 -p1
%patch20 -p1
%patch21 -p1
%patch22 -p1

%build
export CROSS=""

# Workaround for problems on the TPS machines.  They have a
# environment variable called "RELEASE" which somehow confuses the
# SLOF Makefiles which also use a variable named RELEASE.
unset RELEASE

make qemu %{?_smp_mflags} V=2

%install
mkdir -p $RPM_BUILD_ROOT%{_datadir}/qemu-kvm
install -c -m 0644 boot_rom.bin $RPM_BUILD_ROOT%{_datadir}/qemu-kvm/slof.bin

%files
%doc LICENSE
%doc README
%dir %{_datadir}/qemu-kvm
%{_datadir}/qemu-kvm/slof.bin

%changelog
* Fri Aug 05 2016 Miroslav Rezanina <mrezanin@redhat.com> - 20160223-6.gitdbbfda4.el7
- slof-usb-Move-XHCI-port-state-arrays-from-header-to-.c-fi.patch [bz#1352765]
- slof-usb-Increase-amount-of-maximum-slot-IDs-and-add-a-sa.patch [bz#1352765]
- slof-usb-Initialize-USB3-devices-on-a-hub-and-keep-track-.patch [bz#1352765]
- slof-usb-Build-correct-route-string-for-USB3-devices-behi.patch [bz#1352765]
- slof-usb-Set-XHCI-slot-speed-according-to-port-status.patch [bz#1352765]
- Resolves: bz#1352765
  (SLOF can not handle devices attached to an XHCI USB hub)

* Tue Jul 26 2016 Miroslav Rezanina <mrezanin@redhat.com> - 20160223-5.gitdbbfda4.el7
- slof-usb-hid-Fix-non-working-comma-key.patch [bz#1352821]
- Resolves: bz#1352821
  (Key  "," can not be inputted during SLOF and yaboot stage)

* Tue Jun 07 2016 Miroslav Rezanina <mrezanin@redhat.com> - 20160223-4.gitdbbfda4.el7
- slof-xhci-add-memory-barrier-after-filling-the-trb.patch [bz#1339528]
- slof-xhci-fix-missing-keys-from-keyboard.patch [bz#1339528]
- slof-Improve-F12-key-handling-in-boot-menu.patch [bz#1339528]
- Resolves: bz#1339528
  (SLOF boot menu gets delayed if press 'F12' key for multiple times)

* Wed May 11 2016 Miroslav Rezanina <mrezanin@redhat.com> - 20160223-3.gitdbbfda4.el7
- slof-ipv6-Do-not-use-unitialized-MAC-address-array.patch [bz#1287716]
- slof-ipv6-send_ipv6-has-to-return-after-doing-NDP.patch [bz#1287716]
- slof-ipv6-Fix-possible-NULL-pointer-dereference-in-send_i.patch [bz#1287716]
- slof-ipv6-Clear-memory-after-malloc-if-necessary.patch [bz#1287716]
- slof-ipv6-Fix-memory-leak-in-set_ipv6_address-ip6_create_.patch [bz#1287716]
- slof-ipv6-Indent-code-with-tabs-not-with-spaces.patch [bz#1287716]
- slof-ipv6-Fix-NULL-pointer-dereference-in-ip6addr_add.patch [bz#1287716]
- slof-ipv6-Replace-magic-number-1500-with-ETH_MTU_SIZE-i.e.patch [bz#1287716]
- Resolves: bz#1287716
  (IPv6 boot support in SLOF)

* Fri May 06 2016 Miroslav Rezanina <mrezanin@redhat.com> - 20160223-2.gitdbbfda4.el7
- slof-dev-null-The-read-function-has-to-return-0-if-nothin.patch [bz#1310737]
- slof-ipv6-Add-support-for-sending-packets-through-a-route.patch [bz#1301081]
- slof-virtio-net-initialize-to-populate-mac-address.patch [bz#1331698]
- Resolves: bz#1301081
  (IPv6 boot does not work in SLOF when TFTP server is behind a router)
- Resolves: bz#1310737
  (SLOF cannot boot without a console)
- Resolves: bz#1331698
  (Network booting in grub fails when using virtio-net and SLOF-20160223-0)

* Thu Apr 28 2016 Miroslav Rezanina <mrezanin@redhat.com> - 20160223-1.gitdbbfda4.el7
- Rebase to 20160223 version
- Resolves: bz#1279954
  (Rebase SLOF to the version that matches qemu-kvm-rhev in RHEL 7.3)

* Fri Sep 18 2015 Miroslav Rezanina <mrezanin@redhat.com> - 20150313-5.gitc89b0df.el7
- slof-pci-Use-QEMU-created-PCI-device-nodes.patch [bz#1250326]
- Resolves: bz#1250326
  (vfio device can't be hot unplugged on powerpc guest)

* Wed Sep 16 2015 Miroslav Rezanina <mrezanin@redhat.com> - 20150313-4.gitc89b0df.el7
- slof-cas-Increase-FDT-buffer-size-to-accomodate-larger-ib.patch [bz#1263039]
- slof-Downstream-only-Correctly-set-ibm-my-drc-index.patch [bz#1250326]
- Resolves: bz#1250326
  (vfio device can't be hot unplugged on powerpc guest)
- Resolves: bz#1263039
  (SLOF doesn't allow enough room for CAS response with large maxmem)

* Thu Aug 06 2015 Miroslav Rezanina <mrezanin@redhat.com> - 20150313-3.gitc89b0df.el7
- slof-fbuffer-Improve-invert-region-helper.patch [bz#1237052]
- slof-fbuffer-Use-a-smaller-cursor.patch [bz#1237052]
- slof-terminal-Disable-the-terminal-write-trace-by-default.patch [bz#1237052]
- slof-fbuffer-Precalculate-line-length-in-bytes.patch [bz#1237052]
- slof-fbuffer-Implement-MRMOVE-as-an-accelerated-primitive.patch [bz#1237052]
- slof-fbuffer-Implement-RFILL-as-an-accelerated-primitive.patch [bz#1237052]
- slof-Add-missing-half-word-access-case-to-_FASTRMOVE-and-.patch [bz#1237052]
- Resolves: bz#1237052
  (Curser movement issue - the curser would move right and left before get its position in grub interface of a qemu-kvm guest)

* Tue Jun 09 2015 Miroslav Rezanina <mrezanin@redhat.com> - 20150313-2.gitc89b0df.el7
- slof-fbuffer-simplify-address-computations-in-fb8-toggle-.patch [bz#1212256]
- slof-fbuffer-introduce-the-invert-region-helper.patch [bz#1212256]
- slof-fbuffer-introduce-the-invert-region-x-helper.patch [bz#1212256]
- slof-spec-Remove-FlashingSLOF.pdf.patch [bz#1226264]
- Resolves: bz#1212256
  ([Power KVM] Grub interface of guest response slow)
- Resolves: bz#1226264
  (Remove FlashingSLOF.pdf)

* Thu May 28 2015 Miroslav Rezanina <mrezanin@redhat.com> - 20150313-1.gitc89b0df
- rebase to 20150313 version
- Resolves: bz#1225720
  (Update SLOF package to match current qemu-kvm-rhev package)

* Tue Jan 27 2015 Miroslav Rezanina <mrezanin@redhat.com> - 20140630-4.gitf284ab3
- slof-Downstream-only-Workaround-for-TPS-environment-oddit.patch [bz#1183927]
- Resolves: bz#1183927
  (TPS srpm rebuild test failure for SLOF)

* Fri Nov 14 2014 Miroslav Rezanina <mrezanin@redhat.com> - 20140630-3.gitf284ab3
- slof-net-snk-use-socket-descriptor-in-the-network-stack.patch [bz#1158217]
- slof-ipv4-Fix-send-packet-across-a-subnet.patch [bz#1158217]
- Resolves: bz#1158217
  (SLOF can not reach tftp server on different subnet)

* Thu Aug 28 2014 Miroslav Rezanina <mrezanin@redhat.com> - 20140630-2.gitf284ab3
- building as noarch

* Tue Jun 24 2014 Miroslav Rezanina <mrezanin@redhat.com> - 20140630-1.gitf284ab3
- Initial version
